src/Pure/build-jars
author wenzelm
Tue May 30 22:06:39 2017 +0200 (2017-05-30)
changeset 65977 c51b74be23b6
parent 65790 91940684a267
child 65983 d8c5603c1732
permissions -rwxr-xr-x
provide preview content on Scala side (similar to output);
     1 #!/usr/bin/env bash
     2 #
     3 # Author: Makarius
     4 #
     5 # build-jars - build Isabelle/Scala
     6 #
     7 # Requires proper Isabelle settings environment.
     8 
     9 ## sources
    10 
    11 declare -a SOURCES=(
    12   Admin/build_cygwin.scala
    13   Admin/build_doc.scala
    14   Admin/build_docker.scala
    15   Admin/build_history.scala
    16   Admin/build_jdk.scala
    17   Admin/build_log.scala
    18   Admin/build_polyml.scala
    19   Admin/build_release.scala
    20   Admin/build_status.scala
    21   Admin/check_sources.scala
    22   Admin/ci_profile.scala
    23   Admin/isabelle_cronjob.scala
    24   Admin/isabelle_devel.scala
    25   Admin/jenkins.scala
    26   Admin/news.scala
    27   Admin/other_isabelle.scala
    28   Admin/remote_dmg.scala
    29   Concurrent/consumer_thread.scala
    30   Concurrent/counter.scala
    31   Concurrent/event_timer.scala
    32   Concurrent/future.scala
    33   Concurrent/mailbox.scala
    34   Concurrent/par_list.scala
    35   Concurrent/standard_thread.scala
    36   Concurrent/synchronized.scala
    37   GUI/color_value.scala
    38   GUI/gui.scala
    39   GUI/gui_thread.scala
    40   GUI/html5_panel.scala
    41   GUI/jfx_gui.scala
    42   GUI/popup.scala
    43   GUI/wrap_panel.scala
    44   General/antiquote.scala
    45   General/bytes.scala
    46   General/codepoint.scala
    47   General/completion.scala
    48   General/date.scala
    49   General/exn.scala
    50   General/file.scala
    51   General/file_watcher.scala
    52   General/graph.scala
    53   General/graph_display.scala
    54   General/graphics_file.scala
    55   General/http.scala
    56   General/json.scala
    57   General/linear_set.scala
    58   General/logger.scala
    59   General/long_name.scala
    60   General/mercurial.scala
    61   General/multi_map.scala
    62   General/output.scala
    63   General/path.scala
    64   General/position.scala
    65   General/pretty.scala
    66   General/properties.scala
    67   General/scan.scala
    68   General/sha1.scala
    69   General/sql.scala
    70   General/ssh.scala
    71   General/symbol.scala
    72   General/time.scala
    73   General/timing.scala
    74   General/untyped.scala
    75   General/url.scala
    76   General/utf8.scala
    77   General/value.scala
    78   General/word.scala
    79   General/xz.scala
    80   Isar/document_structure.scala
    81   Isar/keyword.scala
    82   Isar/line_structure.scala
    83   Isar/outer_syntax.scala
    84   Isar/parse.scala
    85   Isar/token.scala
    86   ML/ml_console.scala
    87   ML/ml_lex.scala
    88   ML/ml_process.scala
    89   ML/ml_statistics.scala
    90   ML/ml_syntax.scala
    91   PIDE/command.scala
    92   PIDE/command_span.scala
    93   PIDE/document.scala
    94   PIDE/document_id.scala
    95   PIDE/editor.scala
    96   PIDE/line.scala
    97   PIDE/markup.scala
    98   PIDE/markup_tree.scala
    99   PIDE/protocol.scala
   100   PIDE/protocol_handlers.scala
   101   PIDE/protocol_message.scala
   102   PIDE/prover.scala
   103   PIDE/query_operation.scala
   104   PIDE/rendering.scala
   105   PIDE/resources.scala
   106   PIDE/session.scala
   107   PIDE/text.scala
   108   PIDE/xml.scala
   109   PIDE/yxml.scala
   110   ROOT.scala
   111   System/bash.scala
   112   System/command_line.scala
   113   System/cygwin.scala
   114   System/distribution.scala
   115   System/getopts.scala
   116   System/invoke_scala.scala
   117   System/isabelle_charset.scala
   118   System/isabelle_process.scala
   119   System/isabelle_system.scala
   120   System/isabelle_tool.scala
   121   System/numa.scala
   122   System/options.scala
   123   System/platform.scala
   124   System/posix_interrupt.scala
   125   System/process_result.scala
   126   System/progress.scala
   127   System/system_channel.scala
   128   Thy/html.scala
   129   Thy/present.scala
   130   Thy/sessions.scala
   131   Thy/thy_header.scala
   132   Thy/thy_info.scala
   133   Thy/thy_syntax.scala
   134   Tools/bibtex.scala
   135   Tools/build.scala
   136   Tools/check_keywords.scala
   137   Tools/debugger.scala
   138   Tools/doc.scala
   139   Tools/imports.scala
   140   Tools/main.scala
   141   Tools/print_operation.scala
   142   Tools/profiling_report.scala
   143   Tools/simplifier_trace.scala
   144   Tools/spell_checker.scala
   145   Tools/task_statistics.scala
   146   Tools/update_cartouches.scala
   147   Tools/update_header.scala
   148   Tools/update_then.scala
   149   Tools/update_theorems.scala
   150   library.scala
   151   term.scala
   152   term_xml.scala
   153   ../Tools/Graphview/graph_file.scala
   154   ../Tools/Graphview/graph_panel.scala
   155   ../Tools/Graphview/graphview.scala
   156   ../Tools/Graphview/layout.scala
   157   ../Tools/Graphview/main_panel.scala
   158   ../Tools/Graphview/metrics.scala
   159   ../Tools/Graphview/model.scala
   160   ../Tools/Graphview/mutator.scala
   161   ../Tools/Graphview/mutator_dialog.scala
   162   ../Tools/Graphview/mutator_event.scala
   163   ../Tools/Graphview/popups.scala
   164   ../Tools/Graphview/shapes.scala
   165   ../Tools/Graphview/tree_panel.scala
   166   ../Tools/VSCode/src/build_vscode.scala
   167   ../Tools/VSCode/src/channel.scala
   168   ../Tools/VSCode/src/document_model.scala
   169   ../Tools/VSCode/src/dynamic_output.scala
   170   ../Tools/VSCode/src/dynamic_preview.scala
   171   ../Tools/VSCode/src/grammar.scala
   172   ../Tools/VSCode/src/protocol.scala
   173   ../Tools/VSCode/src/server.scala
   174   ../Tools/VSCode/src/vscode_rendering.scala
   175   ../Tools/VSCode/src/vscode_resources.scala
   176 )
   177 
   178 
   179 ## diagnostics
   180 
   181 PRG="$(basename "$0")"
   182 
   183 function usage()
   184 {
   185   echo
   186   echo "Usage: isabelle $PRG [OPTIONS]"
   187   echo
   188   echo "  Options are:"
   189   echo "    -f           fresh build"
   190   echo
   191   exit 1
   192 }
   193 
   194 function fail()
   195 {
   196   echo "$1" >&2
   197   exit 2
   198 }
   199 
   200 [ -z "$ISABELLE_HOME" ] && fail "Missing Isabelle settings environment"
   201 
   202 
   203 ## process command line
   204 
   205 # options
   206 
   207 FRESH=""
   208 
   209 while getopts "f" OPT
   210 do
   211   case "$OPT" in
   212     f)
   213       FRESH=true
   214       ;;
   215     \?)
   216       usage
   217       ;;
   218   esac
   219 done
   220 
   221 shift $(($OPTIND - 1))
   222 
   223 
   224 # args
   225 
   226 [ "$#" -ne 0 ] && usage
   227 
   228 
   229 ## build
   230 
   231 TARGET_DIR="$ISABELLE_HOME/lib/classes"
   232 TARGET="$TARGET_DIR/Pure.jar"
   233 
   234 declare -a UPDATED=()
   235 
   236 if [ -n "$FRESH" ]; then
   237   OUTDATED=true
   238 else
   239   OUTDATED=false
   240   if [ ! -e "$TARGET" ]; then
   241     OUTDATED=true
   242   else
   243     for DEP in "${SOURCES[@]}"
   244     do
   245       [ ! -e "$DEP" ] && fail "Missing file: $DEP"
   246       [ "$DEP" -nt "$TARGET" ] && {
   247         OUTDATED=true
   248         UPDATED["${#UPDATED[@]}"]="$DEP"
   249       }
   250     done
   251   fi
   252 fi
   253 
   254 if [ "$OUTDATED" = true ]
   255 then
   256   echo "### Building Isabelle/Scala ..."
   257 
   258   [ "${#UPDATED[@]}" -gt 0 ] && {
   259     echo "Changed files:"
   260     for FILE in "${UPDATED[@]}"
   261     do
   262       echo "  $FILE"
   263     done
   264   }
   265 
   266   rm -f "$TARGET"
   267   rm -rf classes && mkdir classes
   268 
   269   SCALAC_OPTIONS="$ISABELLE_SCALAC_OPTIONS -d classes"
   270 
   271   (
   272     classpath "$JAVA_HOME/lib/jfxrt.jar"
   273     classpath classes
   274     export CLASSPATH="$(platform_path "$ISABELLE_CLASSPATH")"
   275 
   276     isabelle_scala scalac $SCALAC_OPTIONS "${SOURCES[@]}" || \
   277       fail "Failed to compile sources"
   278   ) || exit "$?"
   279 
   280   mkdir -p "$TARGET_DIR" || fail "Failed to create directory $TARGET_DIR"
   281 
   282   pushd classes >/dev/null
   283 
   284   CHARSET_SERVICE="META-INF/services/java.nio.charset.spi.CharsetProvider"
   285   mkdir -p "$(dirname "$CHARSET_SERVICE")"
   286   echo isabelle.Isabelle_Charset_Provider > "$CHARSET_SERVICE"
   287 
   288   cp "$ISABELLE_HOME/lib/logo/isabelle_transparent-32.gif" isabelle/.
   289   cp "$ISABELLE_HOME/lib/logo/isabelle_transparent.gif" isabelle/.
   290 
   291   isabelle_jdk jar cfe "$(platform_path "$TARGET")" isabelle.Main META-INF isabelle || \
   292     fail "Failed to produce $TARGET"
   293 
   294   popd >/dev/null
   295 
   296   rm -rf classes
   297 fi